<template>
  <a-row type="flex" justify="center">
    <client-only>
      <a-skeleton :loading="$apollo.loading" :active="true" :title="{ width: 100 }" :avatar="{ size: 300, shape: 'square' }" :paragraph="{ rows: 15 }">
        <a-col :span="24" v-if="product">
          <a-page-header :title="product.name"></a-page-header>
          <a-row>
            <a-col :xs="24" :md="12">
              <a-carousel arrows dots-class="slick-dots slick-thumb" v-if="product.images && product.images.length > 0"
                          class="product-carousel">
                <a slot="customPaging" slot-scope="props">
                  <img :src="getImgUrl(props.i)"/>
                </a>
                <div v-for="i in product.images.length" :key="i">
                  <img :src="getImgUrl(i - 1)"/>
                </div>
              </a-carousel>
            </a-col>
            <a-col :xs="24" :md="12">
              <h1 class="title">{{ product.name }}</h1>
              <p class="description">{{ product.description }}</p>
              <a-statistic class="price" :precision="2" :value="product.price" suffix="€"></a-statistic>
              <br>
              <p>Verfügbare Varianten:</p>
              <a-radio-group v-model="selectedVariant">
                <a-tooltip v-for="variant in availableVariants" :key="variant.id">
                  <template slot="title" v-if="variant.disabled">
                    Ausverkauft
                  </template>
                  <a-radio-button :value="variant.id" :disabled="variant.disabled">
                    {{ variant.name }}
                  </a-radio-button>
                </a-tooltip>
              </a-radio-group>
              <br>
              <br>
              <a-button :type="didPutInCart ? 'default' : 'primary'" size="large"
                        :icon="didPutInCart ? 'check' : 'shopping-cart'" :disabled="!hasVariantSelected"
                        @click="addToCart">In den Einkaufswagen
              </a-button>
            </a-col>
          </a-row>
        </a-col>
      </a-skeleton>
    </client-only>
  </a-row>
</template>

<script lang="ts">
import Vue from 'vue'
import productQuery from '~/apollo/queries/products/product.graphql'
import { Product } from '~/types/types.js'

export default Vue.extend({
  data () {
    return {
      product: {} as Product,
      selectedVariant: '' as string,
      didPutInCart: false as boolean
    }
  },
  computed: {
    availableVariants (): Array<any> {
      if (!this.product.variants) {
        return []
      }
      return this.product.variants.map((variant) => ({
        ...variant,
        disabled: variant.inStock <= 0
      }))
    },
    hasVariantSelected (): boolean {
      return this.selectedVariant.length > 0
    }
  },
  methods: {
    getImgUrl (i: number) {
      if (this.product.images[i].url.startsWith('http')) {
        return this.product.images[0].url
      }
      return `${process.env.strapiBaseUri}${this.product.images[i].url}`
    },
    addToCart () {
      if (!this.hasVariantSelected || this.didPutInCart) {
        return
      }
      const variant = this.availableVariants.find((current) => current.id === this.selectedVariant)
      if (!variant) {
        return
      }
      this.didPutInCart = true
      this.$store.commit('cart/add', {
        ...variant,
        product: this.product
      })
      setTimeout(() => {
        this.didPutInCart = false
      }, 1500)

    }
  },
  apollo: {
    product: {
      prefetch: true,
      query: productQuery,
      variables () {
        return {
          id: this.$route.params.id
        }
      }
    }
  },
  mounted () {
    if (this.availableVariants.length === 1) {
      this.selectedVariant = this.availableVariants[0].id
    }
  }
})
</script>
<style lang="scss" scoped>
.title {
  font-size: 2.5rem;
}

.description {
  font-size: 1rem;
}

.price {
  font-size: 2.5rem;
}
</style>

<style lang="scss">
.product-carousel .slick-dots {
  height: auto;
  color: red !important;
}

.product-carousel .slick-slide img {
  border: 5px solid #fff;
  display: block;
  margin: auto;
  max-width: 80%;
  max-height: 500px;
  object-fit: cover;
}

.product-carousel .slick-thumb {
  bottom: -45px;
}

.product-carousel .slick-thumb li {
  width: 60px;
  height: 45px;
}

.product-carousel .slick-thumb li img {
  width: 100%;
  height: 100%;
  filter: grayscale(100%);
}

.product-carousel .slick-thumb li.slick-active img {
  filter: grayscale(0%);
}

.product-carousel {
  margin-bottom: 80px;
}
</style>
